//+------------------------------------------------------------------+
//|                                                AdjustObjects.mq4 |
//|                             Copyright  2007, Troshenkin Andrey. |
//|                                                 troshenkin@bk.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Troshenkin Andrey."
#property link      "troshenkin@bk.ru"

//+------------------------------------------------------------------+
//|                                                          |
//+------------------------------------------------------------------+
//     -  100%  0%  
//     ,  ,    
//     1.
//
//   -      
// ( , ..      )  
//     100% - 0% . 
// -       ,  
//    .
//+------------------------------------------------------------------+


#include <TFColor.mqh>
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
{
   datetime dtFStart, dtFEnd, dtTLStart, dtTLEnd, dtCurTLStart, dtCurTLEnd, dtTemp;
   double nFTop, nFBottom, nTLTop, nTLBottom, nCurTLTop, nCurTLBottom, nTemp;
   int i, n;
   int nObjTotal = ObjectsTotal();
   string sFiboName, sTLName, sObjName, sTypeName;
   color clFibo;
   int nSpaceIndex, nPeriod, nEndBar, nStartBar, nAdjustPeriod, nFoundBar;
   bool bUp;

   //      
   for(n=0; n < nObjTotal; n++)
   {
      sFiboName = ObjectName(n);
      
      if (sFiboName == "")
         continue;
      if (!IsObjectVisible(sFiboName))
         continue;
      
      if (ObjectType(sFiboName) == OBJ_TREND)
      {
         sTLName = sFiboName;
         
         if (ObjectGet(sTLName, OBJPROP_STYLE) != STYLE_SOLID)
            continue;
            
         //if (ObjectGet(sTLName, OBJPROP_WIDTH) != TRENDLINE_WIDTH())
         //   continue;
            
         nSpaceIndex = StringFind(sTLName, " ", 1);
         if (nSpaceIndex < 0)
            continue;

         sTypeName = StringSubstr(sTLName, 0, nSpaceIndex);
         
         if (sTypeName != "Trendline")
            continue;
            
         //    1
         //      
         dtTLStart = ObjectGet(sTLName, OBJPROP_TIME1);
         dtTLEnd = ObjectGet(sTLName, OBJPROP_TIME2);

         nTLTop = ObjectGet(sTLName, OBJPROP_PRICE1);
         nTLBottom = ObjectGet(sTLName, OBJPROP_PRICE2);
         
         PrintD(sTLName + " " + TimeToStr(dtTLStart) + " " + TimeToStr(dtTLEnd) + " | " + nTLTop + " " + nTLBottom);

         bUp = true;
         if ( ((dtTLEnd > dtTLStart) && (nTLTop > nTLBottom)) || ((dtTLEnd < dtTLStart) && (nTLTop < nTLBottom)) )
            bUp = false;

         nPeriod = GetTFByColor(ObjectGet(sTLName, OBJPROP_COLOR));
         
         //       
         if (dtTLStart > dtTLEnd)
            bUp = !bUp;

         ObjectSet(sTLName, OBJPROP_TIME1, GetExectTLTime(dtTLStart, nTLTop, !bUp, nPeriod));
         ObjectSet(sTLName, OBJPROP_TIME2, GetExectTLTime(dtTLEnd, nTLBottom, bUp, nPeriod));
      }
      else if (ObjectType(sFiboName) == OBJ_FIBO)
      {
         dtFStart = ObjectGet(sFiboName, OBJPROP_TIME2);
         dtFEnd = ObjectGet(sFiboName, OBJPROP_TIME1);   

         if (dtFStart > dtFEnd)
         {
            dtTemp = dtFStart;
            dtFStart = dtFEnd;
            dtFEnd = dtTemp;
         }
      
         nFTop = ObjectGet(sFiboName, OBJPROP_PRICE1);
         nFBottom = ObjectGet(sFiboName, OBJPROP_PRICE2);

         if (nFTop < nFBottom)
         {
            nTemp = nFTop;
            nFTop = nFBottom;
            nFBottom = nTemp;
         }

         clFibo = ObjectGet(sFiboName, OBJPROP_LEVELCOLOR);
         PrintD(sFiboName + ": " + dtFStart + " " + dtFEnd + " | " + nFTop + " " + nFBottom);

         //      (TrendLine)
         sTLName = "";
         nTLTop = 0;
         nTLBottom = 0;
         for(i=0; i < nObjTotal; i++)
         {
            sObjName = ObjectName(i);
            if ( (ObjectType(sObjName) == OBJ_TREND) && (clFibo == ObjectGet(sObjName, OBJPROP_COLOR)) 
               && IsObjectVisible(sObjName)
               && !((ObjectGet(sObjName, OBJPROP_STYLE) == STYLE_SOLID) && (ObjectGet(sObjName, OBJPROP_WIDTH) == 0) ) )
            {
               dtCurTLStart = ObjectGet(sObjName, OBJPROP_TIME1);
               dtCurTLEnd = ObjectGet(sObjName, OBJPROP_TIME2);
            
               if (dtCurTLStart > dtCurTLEnd)
               {
                  dtTemp = dtCurTLStart;
                  dtCurTLStart = dtCurTLEnd;
                  dtCurTLEnd = dtTemp;
               }
            
               nCurTLTop = ObjectGet(sObjName, OBJPROP_PRICE1);
               nCurTLBottom = ObjectGet(sObjName, OBJPROP_PRICE2);
               if (nCurTLTop < nCurTLBottom)
               {
                  nTemp = nCurTLTop;
                  nCurTLTop = nCurTLBottom;
                  nCurTLBottom = nTemp;
               }

               PrintD(sObjName + " " + dtCurTLStart + " " + dtCurTLEnd + " | " + nCurTLTop + " " + nCurTLBottom);

               if ((nCurTLTop <= nFTop) && (nCurTLBottom >= nFBottom) && (dtCurTLStart >= dtFStart) )
               {
                  if (nTLTop == 0)
                  {
                     nTLTop = nCurTLTop;
                     nTLBottom = nCurTLBottom;
                     sTLName = sObjName;
                  }
                  else
                  {
                     if (  ((nFTop - nCurTLTop) + (nCurTLBottom - nFBottom)) < ((nFTop - nTLTop) + (nTLBottom - nFBottom)) )
                     {
                        nTLTop = nCurTLTop;
                        nTLBottom = nCurTLBottom;
                        sTLName = sObjName;
                     }
                  }
               }            
            }
         }       

         if (sTLName != "")
         {
            PrintD("Set: " + sTLName);
            //     
            nFTop = ObjectGet(sFiboName, OBJPROP_PRICE1);
            nFBottom = ObjectGet(sFiboName, OBJPROP_PRICE2);
            if (nFTop > nFBottom)
            {
               nFTop = nTLTop;
               nFBottom = nTLBottom;
            }
            else
            {
               nFTop = nTLBottom;
               nFBottom = nTLTop;
            }
         
            ObjectSet(sFiboName, OBJPROP_PRICE1, nFTop);
            ObjectSet(sFiboName, OBJPROP_PRICE2, nFBottom);
         }
      } 
   }   
   

   return(0);
}
//+------------------------------------------------------------------+


datetime GetExectTLTime(datetime dtTime, double nPrice, bool bHigh, int nPeriod)
{
   int i, nEndBar, nStartBar, nAdjustPeriod, nFoundBar;
   datetime dtResult = dtTime;
 
   //   M1
   nStartBar = -1;
   nAdjustPeriod = -1;

   //        
   for(i=0; i < ArraySize(REAL_TF); i++)
   {
      if (REAL_TF[i] == nPeriod)
         break;

      PrintD(REAL_TF[i] + " " + iBars(Symbol(), REAL_TF[i]) + " " + TimeToStr(iTime(Symbol(), REAL_TF[i], iBars(Symbol(), REAL_TF[i])-1)));
      if (iTime(Symbol(), REAL_TF[i], iBars(Symbol(), REAL_TF[i])-1) < dtTime)
      {
         nAdjustPeriod = REAL_TF[i];
         break;
      }
   }

   PrintD(nPeriod + " " + nAdjustPeriod + " " + TimeToStr(dtTime));
   
   if (nAdjustPeriod == -1)
      return (dtResult);
   
   for(i=0; i < iBars(Symbol(), nAdjustPeriod); i++)
   {
      if (iTime(Symbol(), nAdjustPeriod, i) < dtTime)
      {
         nStartBar = i;
         nEndBar = nStartBar - nPeriod/nAdjustPeriod;
         if (nEndBar < 0)
            nEndBar = 0;
            
         break;
      }     
   }
   
   if (nStartBar == -1)
      return (dtResult);

   PrintD(nAdjustPeriod + " " + TimeToStr(iTime(Symbol(), nAdjustPeriod, nStartBar)) + " " + TimeToStr(iTime(Symbol(), nAdjustPeriod, nEndBar)));

   //     nPeriod    dtCurTLEnd
   nFoundBar = -1;
   for(i=nStartBar; i >= nEndBar; i--)
   {
      if ( 
            (bHigh && (iHigh(Symbol(), nAdjustPeriod, i) == nPrice)) || 
            ((!bHigh) && (iLow(Symbol(), nAdjustPeriod, i) == nPrice)) 
         )
      {
         nFoundBar = i;
         //    ,  
         if (iTime(Symbol(), nAdjustPeriod, nFoundBar) == dtTime)
         {
            PrintD("Second time");
            break;
         }
      }
   }
 
   PrintD(TimeToStr(iTime(Symbol(), nAdjustPeriod, nStartBar)) + " " + TimeToStr(iTime(Symbol(), nAdjustPeriod, nFoundBar)));
   
   if (nFoundBar != -1)
      dtResult = iTime(Symbol(), nAdjustPeriod, nFoundBar);
      
   return (dtResult);
}