//+------------------------------------------------------------------+
//|                                                 ClearGrafics.mq4 |
//|                             Copyright  2007, Troshenkin Andrey. |
//|                                                 troshenkin@bk.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Troshenkin Andrey."
#property link      "troshenkin@bk.ru"

//+------------------------------------------------------------------+
//|                                                          |
//+------------------------------------------------------------------+
//     ,    
//      "" .   
//  -,        
// ,    ("Add Pivot.mq4"),   
//  ("Add Rectangle.mq4")     .
//
//   #include <TFColorConfig.mqh>
// int MEDIUM_DATED_TF = PERIOD_H1; //TF    
//                                      .
//
//+------------------------------------------------------------------+


#include <TFColor.mqh>

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
{
   int nObjTotal = ObjectsTotal();
   int i, nSpaceIndex, nObjType;
   string sName, sTypeName;
   
   for(i=(nObjTotal-1); i >=0; i--)
   {
      sName = ObjectName(i);
      if (sName == "")
         continue;

      nObjType = ObjectType(sName);


      //   
      if ( (StringGetChar(sName, 0) == '#') && (nObjType == OBJ_TREND || nObjType == OBJ_ARROW) )
      {
         ObjectDelete(sName);
         continue;
      }
      
      if ( nObjType == OBJ_FIBO )
      {
         if ( GetTFByColor(ObjectGet(sName, OBJPROP_COLOR)) < MEDIUM_DATED_TF() )
            ObjectDelete(sName);
            
         continue;
      }
      
      
      //   
      if (nObjType == OBJ_ARROW)
      {
         nSpaceIndex = StringFind(sName, " ", 1);
         if (nSpaceIndex > 0)
         {
            if ( (StringSubstr(sName, 0, nSpaceIndex) == PIVOT_NAME()) && (ObjectGet(sName, OBJPROP_ARROWCODE) == SYMBOL_RIGHTPRICE) )
            {
               ObjectDelete(sName);
               continue;
            }
         }
      }
      
      if (nObjType == OBJ_RECTANGLE)
      {
         if ( StringSubstr(sName, 0, StringLen(RECTANGLE_NAME())) == RECTANGLE_NAME() )
         {
            ObjectDelete(sName);
            continue;
         }
         else
         {
            nSpaceIndex = StringFind(sName, " ", 1);
            if (nSpaceIndex > 0)
            {
               if (StringSubstr(sName, 0, nSpaceIndex) == "Rectangle")
               {
                  ObjectDelete(sName);
                  continue;
               }
            }
         }
      }
      
      //  ,    -
      if (!(nObjType == OBJ_TREND || nObjType == OBJ_TEXT))
         continue;

      nSpaceIndex = StringFind(sName, " ", 1);
      if (nSpaceIndex < 0)
         continue;

      sTypeName = StringSubstr(sName, 0, nSpaceIndex);
         
      if (!( (nObjType == OBJ_TREND && sTypeName == "Trendline") || (nObjType == OBJ_TEXT && sTypeName == "Text") ) )
         continue;
      
      if ( GetTFByColor(ObjectGet(sName, OBJPROP_COLOR)) < MEDIUM_DATED_TF() )
         ObjectDelete(sName);
   }
   
   //  , ..     
   RenameOldObjects();
   
   return(0);
}
//+------------------------------------------------------------------+