//+------------------------------------------------------------------+
//|                                        DelCanceledFiboLevels.mq4 |
//|                             Copyright  2007, Troshenkin Andrey. |
//|                                                 troshenkin@bk.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Troshenkin Andrey."
#property link      "troshenkin@bk.ru"

//+------------------------------------------------------------------+
//|                                                          |
//+------------------------------------------------------------------+
//     -,     
//  (   "AdjustFibo.mq4")   
//   (    ).
//  -  (    0%),   .
//
//   #include <TFColorConfig.mqh>
// int MAX_LEAVE_LEVELS = 1; //    
//                                
//
//+------------------------------------------------------------------+


#include <TFColor.mqh>

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
{
   datetime dtTLLastTime;
   double nFTop, nFBottom, nTLPeak;
   int n, nBarStart, j, nFiboLevels;
   int nObjTotal=ObjectsTotal();
   string sFiboName, sTLName;
   bool bUp, bCorrect;
   double nMax, nMin, nPrice, nValue;
   double arFiboLevelsValues[];
   string arFiboLevelsDesc[];
   string arObjectsToDelete[];
   int nFiboLevelsCount, nCountInPrice, nToDeleteCount;
   bool bTemp[] = {false};
   double nTemp[] = {0};
   int nWindowSize[4];
   
   if (!GetStartEndBars(nWindowSize))
      return (-1);
   
   ArrayResize( arObjectsToDelete, nObjTotal );
   nToDeleteCount = 0;

   //      
   for(n=0; n < nObjTotal; n++)
   {
      sFiboName = ObjectName(n);
         
      if ( (sFiboName != "") && (ObjectType(sFiboName) == OBJ_FIBO) && IsObjectVisible(sFiboName) )
      {
         //      (TrendLine)
         sTLName = FindTrendLineForFiboByName(sFiboName, bTemp, nTemp);
         bUp = bTemp[0];
         nTLPeak = nTemp[0];
         
         if (sTLName != "")
         {
            PrintD("UP " + bUp);
            dtTLLastTime = ObjectGet(sTLName, OBJPROP_TIME1);

            if (dtTLLastTime < ObjectGet(sTLName, OBJPROP_TIME2))
               dtTLLastTime = ObjectGet(sTLName, OBJPROP_TIME2);

            //  
            nBarStart = 0;
            nMax = -1;
            nMin = -1;
            if (!IsTestingMode())
            {
               for(j=0; j < iBars(Symbol(), PERIOD_M1); j++ )
               {
                  if (nMax == -1)
                     nMax = iHigh(Symbol(), PERIOD_M1, j);
                  
                  if (nMin == -1)
                     nMin = iLow(Symbol(), PERIOD_M1, j);
                  
                  if (nMax < iHigh(Symbol(), PERIOD_M1, j))         
                     nMax = iHigh(Symbol(), PERIOD_M1, j);
                  if (nMin > iLow(Symbol(), PERIOD_M1, j))
                     nMin = iLow(Symbol(), PERIOD_M1, j);
               
                  if (iTime(Symbol(), PERIOD_M1, j) <= dtTLLastTime)
                  {
                     nBarStart = j;
                     break;
                  }
               }
            }
            else
            {
               //       ,        
               for(j=nWindowSize[0]; j < Bars; j++ )
               {
                  if (nMax == -1)
                     nMax = High[j];
                  
                  if (nMin == -1)
                     nMin = Low[j];
                  
                  if (nMax < High[j])         
                     nMax = High[j];
                  if (nMin > Low[j])
                     nMin = Low[j];
               
                  if (Time[j] <= dtTLLastTime)
                  {
                     nBarStart = j;
                     break;
                  }
               }
            }
            
            if (nBarStart == 0)
               continue; //fibo

            nFiboLevels = ObjectGet( sFiboName, OBJPROP_FIBOLEVELS);
            nFTop = ObjectGet(sFiboName, OBJPROP_PRICE1);
            nFBottom = ObjectGet(sFiboName, OBJPROP_PRICE2);
            

            //Fibo 49650, nBarStart = 15, Max = 1.49200000, Min = 1.48850000, Top = 1.49040000, Bottom = 1.49270000

            //      
            bCorrect = (IsFiboImpuls(sFiboName) == FIBO_CORRECT);

            PrintD(sFiboName + " IsCorrect = " + bCorrect + ", nBarStart = " + nBarStart + ", Max = " + nMax + ", Min = " + nMin + ", Top = " + nFTop + ", Bottom = " + nFBottom);

            if (bCorrect)
            {
               if (((nMax > nFBottom) && (nMax > nFTop)) || ((nMin < nFBottom) && (nMin < nFTop)))
               {
                  arObjectsToDelete[nToDeleteCount] = sFiboName;
                  nToDeleteCount++;
                  continue;
               }
            }
            else
            {
               if ( (bUp && (nMin < nFBottom)) || ((!bUp) && (nMax > nFBottom)) )
               {
                  arObjectsToDelete[nToDeleteCount] = sFiboName;
                  nToDeleteCount++;
                  continue;
               }
            }
            
            ArrayResize( arFiboLevelsValues, nFiboLevels );
            ArrayResize( arFiboLevelsDesc, nFiboLevels );
            nFiboLevelsCount = 0;
            nCountInPrice = 0;

            //   -      
            if (bCorrect)
            {
               for(j = 0; j < nFiboLevels; j++)
               {
                  nValue = ObjectGet(sFiboName, OBJPROP_FIRSTLEVEL + j);
                  if ((nValue == 0) || (nValue == 1))
                  {
                     arFiboLevelsValues[nFiboLevelsCount] = nValue;
                     arFiboLevelsDesc[nFiboLevelsCount] = ObjectGetFiboDescription(sFiboName, j);

                     PrintD("Add: " + nFiboLevelsCount + " " + arFiboLevelsValues[nFiboLevelsCount] + " " + arFiboLevelsDesc[nFiboLevelsCount]);
                     nFiboLevelsCount++;
                     continue;
                  }
                  
                  nPrice = (nFTop - nFBottom)*nValue + nFBottom;
                  PrintD(nPrice + " " + ObjectGet(sFiboName, OBJPROP_FIRSTLEVEL + j) + ", Max = " + nMax + ", Min = " + nMin + " up" + bUp);
                  if ( ((nPrice >= nMax) && (!bUp)) || ((nPrice <= nMin) && bUp) )
                  {
                     arFiboLevelsValues[nFiboLevelsCount] = nValue;
                     arFiboLevelsDesc[nFiboLevelsCount] = ObjectGetFiboDescription(sFiboName, j);

                     PrintD("Add: " + nFiboLevelsCount + " " + arFiboLevelsValues[nFiboLevelsCount] + " " + arFiboLevelsDesc[nFiboLevelsCount]);
                     nFiboLevelsCount++;
                  }
                  else
                  {
                     nCountInPrice++;
                     if (nCountInPrice <= MAX_LEAVE_LEVELS())
                     {
                        arFiboLevelsValues[nFiboLevelsCount] = nValue;
                        arFiboLevelsDesc[nFiboLevelsCount] = ObjectGetFiboDescription(sFiboName, j);

                        PrintD("Add counted " + nFiboLevelsCount + " " + nCountInPrice + ": " + arFiboLevelsValues[nFiboLevelsCount] + " " + arFiboLevelsDesc[nFiboLevelsCount]);
                        nFiboLevelsCount++;
                     }
                  }
               } //for(j = (nFiboLevels-1); j > 0; j--)

               ObjectSet( sFiboName, OBJPROP_FIBOLEVELS, nFiboLevelsCount);
               for(j=0; j < nFiboLevelsCount; j++)
               {
                  PrintD("Add level: " + arFiboLevelsValues[j] + " " + arFiboLevelsDesc[j]);
                  ObjectSet(sFiboName, OBJPROP_FIRSTLEVEL + j, arFiboLevelsValues[j]);
                  ObjectSetFiboDescription(sFiboName, j, arFiboLevelsDesc[j]);
               }
            } //if (ObjectGet( sFiboName, OBJPROP_LEVELSTYLE ) == STYLE_DASH)
            else
            {
               //  
               for(j = (nFiboLevels-1); j >=0 ; j--)
               {
                  nValue = ObjectGet(sFiboName, OBJPROP_FIRSTLEVEL + j);
                  if ((nValue == 0) || (nValue == 1))
                  {
                     arFiboLevelsValues[nFiboLevelsCount] = nValue;
                     arFiboLevelsDesc[nFiboLevelsCount] = ObjectGetFiboDescription(sFiboName, j);

                     PrintD("Add: " + nFiboLevelsCount + " " + arFiboLevelsValues[nFiboLevelsCount] + " " + arFiboLevelsDesc[nFiboLevelsCount]);
                     nFiboLevelsCount++;
                     continue;
                  }
                  
                  nPrice = (nFTop - nFBottom)*nValue + nFBottom;
                  PrintD(nPrice + " " + ObjectGet(sFiboName, OBJPROP_FIRSTLEVEL + j));
                  if ( ((nPrice <= nMin) && (!bUp)) || ((nPrice >= nMax) && bUp) )
                  {
                     arFiboLevelsValues[nFiboLevelsCount] = nValue;
                     arFiboLevelsDesc[nFiboLevelsCount] = ObjectGetFiboDescription(sFiboName, j);

                     PrintD("Add: " + nFiboLevelsCount + " " + arFiboLevelsValues[nFiboLevelsCount] + " " + arFiboLevelsDesc[nFiboLevelsCount]);
                     nFiboLevelsCount++;
                  }
                  else
                  {
                     nCountInPrice++;
                     if (nCountInPrice <= MAX_LEAVE_LEVELS())
                     {
                        arFiboLevelsValues[nFiboLevelsCount] = nValue;
                        arFiboLevelsDesc[nFiboLevelsCount] = ObjectGetFiboDescription(sFiboName, j);

                        PrintD("Add counted " + nFiboLevelsCount + " " + nCountInPrice + ": " + arFiboLevelsValues[nFiboLevelsCount] + " " + arFiboLevelsDesc[nFiboLevelsCount]);
                        nFiboLevelsCount++;
                     }
                  }
               } //for(j = (nFiboLevels-1); j > 0; j--)

               ObjectSet( sFiboName, OBJPROP_FIBOLEVELS, nFiboLevelsCount);
               for(j=0; j < nFiboLevelsCount; j++)
               {
                  PrintD("Add level: " + arFiboLevelsValues[j] + " " + arFiboLevelsDesc[j]);
                  ObjectSet(sFiboName, OBJPROP_FIRSTLEVEL + nFiboLevelsCount-j-1, arFiboLevelsValues[j]);
                  ObjectSetFiboDescription(sFiboName, nFiboLevelsCount-j-1, arFiboLevelsDesc[j]);
               }
            } //else - if (ObjectGet( sFiboName, OBJPROP_LEVELSTYLE ) == STYLE_DASH)
         } //if (sTLName != "")
      } 
   } //for(n=0; n < nObjTotal; n++)
   
   //  
   for(n=0; n < nToDeleteCount; n++)
   {
      ObjectDelete(arObjectsToDelete[n]);
      Print("Delete " + arObjectsToDelete[n]);
   }   
   
   return(0);
}
//+------------------------------------------------------------------+