//+------------------------------------------------------------------+
//|                                      RefreshObjectsViewOneTF.mq4 |
//|                              Copyright  2007, Troshenkin Andrey |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Troshenkin Andrey"
#property link      "troshenkin@bk.ru"

//+------------------------------------------------------------------+
//|                                                          |
//+------------------------------------------------------------------+
//       ,  
//        .
//+------------------------------------------------------------------+


#include <TFColor.mqh>

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
{
   int i;
   int obj_total=ObjectsTotal();
   string name;
   color objColor;

   bool bNeedShowAllTF = true;

   for(i=0; i < obj_total;i++)
   {
      name = ObjectName(i);
      
      if (IsObjectSystem(name))
         continue;

      if ( (ObjectType(name) == OBJ_TREND) || (ObjectType(name) == OBJ_FIBO) || (ObjectType(name) == OBJ_TEXT))
      {
         if ( (ObjectGet(name, OBJPROP_TIMEFRAMES) == OBJ_ALL_PERIODS) || (ObjectGet(name, OBJPROP_TIMEFRAMES) == NULL) )
            bNeedShowAllTF = false;
      }
   }

   if (bNeedShowAllTF)
   {
      for(i=0; i < obj_total;i++)
      {
         name = ObjectName(i);
      
         if (IsObjectSystem(name))
            continue;

         if ( (ObjectType(name) == OBJ_TREND) || (ObjectType(name) == OBJ_FIBO) || (ObjectType(name) == OBJ_TEXT))
         {
            ObjectSet(name, OBJPROP_TIMEFRAMES, OBJ_ALL_PERIODS);            
         }
      }
   }
   else
   {
      for(i=0; i< obj_total;i++)
      {
         name = ObjectName(i);
         if (IsObjectSystem(name))
            continue;
         
         if ( (ObjectType(name) == OBJ_TREND) || (ObjectType(name) == OBJ_FIBO) || (ObjectType(name) == OBJ_TEXT))
         {
            objColor = ObjectGet(name, OBJPROP_COLOR);
            if (ObjectType(name) == OBJ_FIBO)
               objColor = ObjectGet(name, OBJPROP_LEVELCOLOR);

            if (objColor == ColorH4() || objColor == ColorH8())
               ObjectSet(name, OBJPROP_TIMEFRAMES, OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1 | OBJ_PERIOD_H4);       
            if (objColor == ColorH1() || objColor == ColorH2())
               ObjectSet(name, OBJPROP_TIMEFRAMES, OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30 | OBJ_PERIOD_H1);       
            if (objColor == ColorM15() || objColor == ColorM30())
               ObjectSet(name, OBJPROP_TIMEFRAMES, OBJ_PERIOD_M1 | OBJ_PERIOD_M5 | OBJ_PERIOD_M15 | OBJ_PERIOD_M30);       
            if (objColor == ColorM5() || objColor == ColorM10())
               ObjectSet(name, OBJPROP_TIMEFRAMES, OBJ_PERIOD_M1 | OBJ_PERIOD_M5);       
            if (objColor == ColorM1() || objColor == ColorM2())
               ObjectSet(name, OBJPROP_TIMEFRAMES, OBJ_PERIOD_M1);       
         }
      }
   }
   
   return(0);
}
//+------------------------------------------------------------------+