//+------------------------------------------------------------------+
//|                                               SaveFiboLevels.mq4 |
//|                             Copyright  2007, Troshenkin Andrey. |
//|                                                 troshenkin@bk.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Troshenkin Andrey."
#property link      "troshenkin@bk.ru"

//+------------------------------------------------------------------+
//|                                                          |
//+------------------------------------------------------------------+
//     -     
//    " Mt4\experts\files\FiboLevels.txt".
//      " /", 
//     .
//      ,   
// TF           
//  -.
//
//   #include <TFColorConfig.mqh>
// string SAVE_FIBO_LEVELS_FILE_NAME = "/FiboLevels.txt";
//
//+------------------------------------------------------------------+


#include <TFColor.mqh>

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
{
   int file_handle = -1;
   string file_name = SAVE_FIBO_LEVELS_FILE_NAME();

   datetime dtFStart, dtFEnd;
   double nFTop, nFBottom, nTemp, nPrice;
   int i, j;
   int nObjTotal=ObjectsTotal();
   string sFiboName, sTFName, sDesc, sFiboStyle, sLetter;
   color clFibo;
   int nFiboStyle;

	file_handle = FileOpen ( file_name, FILE_WRITE);

   if ( file_handle == 0 ) 
      return (0);

   FileWrite(file_handle, Symbol());
   
   //      
   for(i=0; i < nObjTotal; i++)
   {
      sFiboName = ObjectName(i);
         
      if ( (sFiboName != "") && (ObjectType(sFiboName) == OBJ_FIBO) && IsObjectVisible(sFiboName) )
      {
         dtFStart = ObjectGet(sFiboName, OBJPROP_TIME2);
         dtFEnd = ObjectGet(sFiboName, OBJPROP_TIME1);   

         clFibo = ObjectGet(sFiboName, OBJPROP_LEVELCOLOR);         
         sTFName = GetTFNameByColor(clFibo);

         nFTop = ObjectGet(sFiboName, OBJPROP_PRICE1);
         nFBottom = ObjectGet(sFiboName, OBJPROP_PRICE2);

         //        
         sLetter = GetFiboWaveName(nFTop, nFBottom, dtFStart, dtFEnd, clFibo);

         nFiboStyle = ObjectGet( sFiboName, OBJPROP_LEVELSTYLE); 
         
         if (nFiboStyle == STYLE_DASH)
            sFiboStyle = " ";
         else
            sFiboStyle = " ";
   
         FileWrite(file_handle, "");
         FileWrite(file_handle, sFiboStyle + " - " + sLetter + " " + sTFName + " " + DoubleToStr(nFTop, 4) + "-" + DoubleToStr(nFBottom, 4));
         for(j=0; j < ObjectGet(sFiboName, OBJPROP_FIBOLEVELS); j++)
         {
            nPrice = (nFTop - nFBottom)*ObjectGet(sFiboName, OBJPROP_FIRSTLEVEL + j) + nFBottom;
            sDesc = StringTrimLeft(ObjectGetFiboDescription(sFiboName, j));
            if (sDesc == "")
               continue;

            if (StringFind(sDesc, " ") > 0)
               sDesc = StringSubstr(sDesc, 0, StringFind(sDesc, " "));
            
            sDesc = DoubleToStr(nPrice, 4) + " - " + sDesc + "% " + sLetter + " " + sTFName; 
            FileWrite(file_handle, sDesc);
         }
      }
   }   
   
   FileFlush( file_handle );
   FileClose( file_handle );

   return(0);
}
//+------------------------------------------------------------------+

