//+------------------------------------------------------------------+
//|                                                    SetImpuls.mq4 |
//|                             Copyright  2007, Troshenkin Andrey. |
//|                                                 troshenkin@bk.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Troshenkin Andrey."
#property link      "troshenkin@bk.ru"

//+------------------------------------------------------------------+
//|                                                          |
//+------------------------------------------------------------------+
//     -   .
//    -     (   100%).
//     ,       
// ,         .
//
//   #include <TFColorConfig.mqh>
// double FIBO_LEVELS[] = {0.0, 0.118, 0.236, 0.382, 0.5, 0.618, 0.764, 0.882, 
//                         1.0, 1.118, 1.236, 1.382, 1.5, 1.618, 1.764, 1.882, 
//                         2.0, 2.236, 2.382, 2.5, 2.618, 2.764, 
//                         3.0, 3.236, 3.382, 3.5, 3.618, 3.764, 
//                         4.0, 4.382, 4.5, 4.618};
// bool SHOW_FIBO_PRICE = true;    //true       
// bool SHOW_FIBO_TF = false;      //true       
// bool SHOW_FIBO_WAVE_NAME = true;//true      
//                                          -
// int TRENDLINE_WIDTH = 2;        //  
//
//
//      :
//           
// - (   -    , 
//       -     -), 
//            , 
//   ,    .
// ,         . 
// ..     5 ,    7 ,  
//      5 - 9, .. 5 + (7-5)*2 = 9
//     ,      
//         . 
//
//+------------------------------------------------------------------+


#include <TFColor.mqh>

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
{
   string name = GetLastObjectName();
   int i, nFiboLevels, nWindow, nFiboLevelWidth, nFiboLevelStyle, nFiboWidth, nFiboStyle; 
   color clColor;
   datetime dtFiboTime1, dtFiboTime2;
   double nValue, nFiboPrice1, nFiboPrice2;
   double arFiboLevelsValues[];
   string sLevelDescription, sWaveName, sLevelDescTemplate;
   double arFiboLevels[];
   int nSize;
   
   if (name != "")
   {
      int nObjType = ObjectType(name);
      switch(nObjType)
      {
         case OBJ_FIBO: 
            if ( (clColor == ColorW1()) || (clColor == ColorMN1()) )
            {
               nFiboLevelWidth = 2;
               nFiboLevelStyle = STYLE_SOLID;
            }
            else
            {
               nFiboLevelWidth = 0;
               nFiboLevelStyle = STYLE_DOT;
            }
         
            //  
            nWindow = ObjectFind(name);
            clColor = ObjectGet(name, OBJPROP_LEVELCOLOR);
            nFiboPrice1 = ObjectGet(name, OBJPROP_PRICE1);
            nFiboPrice2 = ObjectGet(name, OBJPROP_PRICE2);
            dtFiboTime1 = ObjectGet(name, OBJPROP_TIME1);
            dtFiboTime2 = ObjectGet(name, OBJPROP_TIME2);
            nFiboWidth = ObjectGet(name, OBJPROP_WIDTH);
            nFiboStyle = ObjectGet(name, OBJPROP_STYLE);
            
            //     
            //    , ..  0, 100%     100%
            
            nSize = FIBO_LEVELS(arFiboLevels);
            
            ArrayResize( arFiboLevelsValues, nSize );
            
            nFiboLevels = 0;
            for(i = 0; i < nSize; i++)
            {
               nValue = arFiboLevels[i];
               if ( (nValue >= 1) || (nValue == 0) ) 
               {
                  arFiboLevelsValues[nFiboLevels] = nValue;      
                  nFiboLevels++;
               }
            }
            
            //  
            ObjectDelete(name);
            
            //          
            if (ObjectCreate(name, OBJ_FIBO, nWindow, dtFiboTime1, nFiboPrice1, dtFiboTime2, nFiboPrice2 ) )
            {
               ObjectSet( name, OBJPROP_COLOR, clColor );
               ObjectSet( name, OBJPROP_LEVELCOLOR, clColor );
               ObjectSet( name, OBJPROP_LEVELSTYLE, nFiboLevelStyle );
               ObjectSet( name, OBJPROP_LEVELWIDTH, nFiboLevelWidth );
               ObjectSet( name, OBJPROP_STYLE, nFiboStyle );
               ObjectSet( name, OBJPROP_WIDTH, nFiboWidth );
               ObjectSet( name, OBJPROP_BACK, true );
               ObjectSet( name, OBJPROP_RAY, false );
               ObjectSet( name, OBJPROP_TIMEFRAMES, OBJ_ALL_PERIODS );
               ObjectSet( name, OBJPROP_FIBOLEVELS, nFiboLevels );
            
               sLevelDescTemplate = "";

               if (SHOW_FIBO_PRICE())
                  sLevelDescTemplate = " (%$)";
                  
               if (SHOW_FIBO_WAVE_NAME())
               {
                  sWaveName = GetFiboWaveName(nFiboPrice1, nFiboPrice2, dtFiboTime1, dtFiboTime2, clColor);
                  if (sWaveName != "")
                     sLevelDescTemplate = sLevelDescTemplate + " " + sWaveName;
               }

               if (SHOW_FIBO_TF())
                  sLevelDescTemplate = sLevelDescTemplate + " " + GetTFNameByColor(clColor);
               
               
               for(i=0; i < nFiboLevels; i++)
               {
                  ObjectSet(name, OBJPROP_FIRSTLEVEL + i, arFiboLevelsValues[i]);
                  
                  sLevelDescription = DoubleToStr(arFiboLevelsValues[i]*100, 1) + sLevelDescTemplate;
                  ObjectSetFiboDescription(name, i, sLevelDescription);
               }
            }
            
            break;
         case OBJ_TREND: 
            if ( (ObjectGet(name, OBJPROP_WIDTH) > 1) || (ObjectGet(name, OBJPROP_STYLE) != STYLE_SOLID) )
            {
               ObjectSet(name, OBJPROP_WIDTH, 0); 
               ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            }
            else
               ObjectSet(name, OBJPROP_WIDTH, TRENDLINE_WIDTH()); 
            
            break;
      }
   } 

   return(0);
}
//+------------------------------------------------------------------+