//+------------------------------------------------------------------+
//|                                                SetNormalFibo.mq4 |
//|                             Copyright  2007, Troshenkin Andrey. |
//|                                                 troshenkin@bk.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Troshenkin Andrey."
#property link      "troshenkin@bk.ru"

//+------------------------------------------------------------------+
//|                                                          |
//+------------------------------------------------------------------+
//   - , ..   -. 
//   ,      - 
// -  ,       .
//
//          
//  (  )    - 
//     (  "OK").
//
//   #include <TFColorConfig.mqh>
// double FIBO_LEVELS[] = {0.0, 0.118, 0.236, 0.382, 0.5, 0.618, 0.764, 0.882, 
//                         1.0, 1.118, 1.236, 1.382, 1.5, 1.618, 1.764, 1.882, 
//                         2.0, 2.236, 2.382, 2.5, 2.618, 2.764, 
//                         3.0, 3.236, 3.382, 3.5, 3.618, 3.764, 
//                         4.0, 4.382, 4.5, 4.618};
// bool CORRECT_FIBO_DOUBLE_NAME = true;//true        88.2 .. 11.8,  false - 11.8.
//
//+------------------------------------------------------------------+


#include <TFColor.mqh>

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
{
   string name = GetLastObjectName();
   double arFiboLevels[];
   int i, nSize;
   string sLevelDescription;
   
   PrintD(name);
   
   if (name != "")
   {
      if (ObjectType(name) != OBJ_FIBO)
         return (0);

      nSize = FIBO_LEVELS(arFiboLevels);
      ObjectSet(name, OBJPROP_FIBOLEVELS, nSize);      

            
      for(i=0; i < nSize; i++)
      {
         ObjectSet(name, OBJPROP_FIRSTLEVEL + i, arFiboLevels[i]);
         
         if (!CORRECT_FIBO_DOUBLE_NAME())
         {
            if ((arFiboLevels[i] < 1) && (arFiboLevels[i] != 0))
               sLevelDescription = DoubleToStr((1 - arFiboLevels[i])*100, 1);
            else 
               sLevelDescription = DoubleToStr(arFiboLevels[i]*100, 1);
         }
         else
         {
            if (arFiboLevels[i] <= 1)
               sLevelDescription = DoubleToStr(arFiboLevels[i]*100, 1) + " .. " + DoubleToStr((1 - arFiboLevels[i])*100, 1);
            else 
               sLevelDescription = DoubleToStr(arFiboLevels[i]*100, 1);
         }
         
         if (SHOW_FIBO_PRICE())
            sLevelDescription = sLevelDescription + " (%$)";
         
         ObjectSetFiboDescription(name, i, sLevelDescription);
      }      
   }
   
      
   return(0);
}
//+------------------------------------------------------------------+