//+------------------------------------------------------------------+
//|                                                    ShowNames.mq4 |
//|                             Copyright  2007, Troshenkin Andrey. |
//|                                                 troshenkin@bk.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Troshenkin Andrey."
#property link      "troshenkin@bk.ru"

//+------------------------------------------------------------------+
//|                                                          |
//+------------------------------------------------------------------+
//      .
//        - , 
//     -  ,     .
//
//     :    ( ), 
//     +  Ctrl       
//     -    . 
//    (   ) -   .
//        TF,  , 
//          ColorM1.mq4  ..
//
//   #include <TFColorConfig.mqh>
// double LETTERS_WINDOW_LENGTH = 0.4; //      ( 0.1  1   ,  1 -    )
// string LETTERS[] = {"A", "B", "C", "a(C)", "b(C)", "c(C)", "1", "2", "3", "4", "5", ""};
// string LETTERS_FONTFACE = "Arial";
// int FONT_SIZE1 = 10;
//
//+------------------------------------------------------------------+


#include <TFColor.mqh>

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
{
   double nTopHeight = 0;
   datetime nNextXPos;
   int i, nFirstBar;
   string arLetters[];
   int nSize = LETTERS(arLetters);
   bool bIsLettersShown = false;
   string sFirstLetter;
   int nWindowSize[2];
   int nOneLetterBarLength;
   double nLettersLength = LETTERS_WINDOW_LENGTH();
   
   
   if (nSize == 0)
      return;

   if (!GetStartEndBars(nWindowSize))
      return (-1);

   if ( (LETTERS_WINDOW_LENGTH() > 1) || (LETTERS_WINDOW_LENGTH() <=0))
   {
      Alert("      0.1 - 1   .");
      return (-1);
   }
   
   nOneLetterBarLength = NormalizeDouble((WindowBarsPerChart()*LETTERS_WINDOW_LENGTH())/nSize, 0);
   PrintD(WindowBarsPerChart() + " " + nSize + " " + nOneLetterBarLength);
   
   if (nOneLetterBarLength < 1)
      nOneLetterBarLength = 1;

   //   
   nFirstBar = nWindowSize[1] - ((WindowBarsPerChart() - (nSize-1)*nOneLetterBarLength)/2);
   //       ,     
   if (!IsTestingMode())
      nFirstBar = nFirstBar - (WindowBarsPerChart() - nSize*nOneLetterBarLength)/6;
   
   nTopHeight = WindowPriceMax() - (WindowPriceMax() - WindowPriceMin())/50;

   //        
   sFirstLetter = LETTERS_NAME() + arLetters[0];
   if (ObjectFind(sFirstLetter) == 0)
      bIsLettersShown = IsObjectVisible(sFirstLetter);
   
   if (!bIsLettersShown)
   {
      nNextXPos = Time[nFirstBar];   
      
      for(i = 0; i < nSize; i++)
      {
         CreateText( LETTERS_NAME() + arLetters[i], nNextXPos, nTopHeight, arLetters[i] );
         nFirstBar = nFirstBar - nOneLetterBarLength;
         if (nFirstBar >= 0)
            nNextXPos = Time[nFirstBar];
         else
            nNextXPos = nNextXPos + nOneLetterBarLength*Period()*60;
      }
   }
   else
   {
      for(i = 0; i < nSize; i++)
         ObjectDelete(LETTERS_NAME() + arLetters[i]);
   }

   WindowRedraw();

   return(0);
}

//+------------------------------------------------------------------+

void CreateText( string sName, datetime t1, double p1, string sLetter )
{
   ObjectDelete(sName);

   if ( ObjectCreate(sName, OBJ_TEXT, 0, t1, p1) )
   {
      ObjectSetText(sName, sLetter, FONT_SIZE1(), LETTERS_FONTFACE(), GetColorByTF(Period()));
      ObjectSet(sName, OBJPROP_BACK, true);
   }
   
   GetLastError();
}